Attribute VB_Name = "mdlWidowsProcedure"
Private Declare Function GetClientRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT) As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function GetProp Lib "user32" Alias "GetPropA" (ByVal hWnd As Long, ByVal lpString As String) As Long
Private Declare Function SetProp Lib "user32" Alias "SetPropA" (ByVal hWnd As Long, ByVal lpString As String, ByVal hData As Long) As Long
Private Declare Function RemoveProp Lib "user32" Alias "RemovePropA" (ByVal hWnd As Long, ByVal lpString As String) As Long
Private Declare Sub MoveMemory Lib "kernel32" Alias "RtlMoveMemory" (pDest As Any, pSource As Any, ByVal dwLength As Long)
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As GWL_nIndex) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As GWL_nIndex, ByVal dwNewLong As Long) As Long
Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function SendMessageLong Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private lpPrevWndProc As Long

Public gHW As Long
#If DEBUGWINDOWPROC Then
    Private m_colWPHooks As New Collection
#End If

Public Function UnSubClass(hWnd As Long) As Boolean
Dim lpfnOld As Long
    lpfnOld = GetProp(hWnd, OLDWNDPROC)
    If lpfnOld Then
        If SetWindowLong(hWnd, GWL_WNDPROC, lpfnOld) Then
            Call RemoveProp(hWnd, OLDWNDPROC)
            Call RemoveProp(hWnd, OBJECTPTR)
            #If DEBUGWINDOWPROC Then
                m_colWPHooks.Remove CStr(hWnd)
            #End If
            UnSubClass = True
        End If
    End If
End Function
Public Function SubClass(hWnd As Long, lpfnNew As Long) As Boolean
    Dim lpfnOld As Long
    Dim fSuccess As Boolean
  
    If (GetProp(hWnd, OLDWNDPROC) = 0) Then
        lpfnOld = SetWindowLong(hWnd, GWL_WNDPROC, lpfnNew)
        If lpfnOld Then
            fSuccess = SetProp(hWnd, OLDWNDPROC, lpfnOld)
        End If
    End If
  
    If fSuccess Then
        SubClass = True
    Else
        If lpfnOld Then Call UnSubClass(hWnd)
    End If
End Function
Public Function WndProc(ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Static lvcd As NMLVCUSTOMDRAW
Select Case uMsg
    Case WM_NOTIFY
        MoveMemory lvcd, ByVal lParam, Len(lvcd)
        '[Scelta del listview di origine]
        Select Case lvcd.nmcd.hdr.code
            Case NM_CUSTOMDRAW
                Static iElement As Long
                Select Case lvcd.nmcd.dwDrawStage
                    Case CDDS_PREPAINT
                        WndProc = CDRF_NOTIFYITEMDRAW
                        Exit Function
                    Case CDDS_ITEMPREPAINT
                        '[Colora le righe alternativamente]
                        If blnRigheAlternate Then
                            If (lvcd.nmcd.dwItemSpec Mod 2) Then
                                lvcd.clrText = InfoRigheAlternate.ColTestoRigheDispari
                                lvcd.clrTextBk = InfoRigheAlternate.ColRigheDispari
                            Else
                                lvcd.clrText = InfoRigheAlternate.ColTestoRighePari
                                lvcd.clrTextBk = InfoRigheAlternate.ColRighePari
                            End If
                        End If
                        
                        '[Colora le righe che contengono un determinato testo]
                        If UCase(Trim(frmMain.L1.ListItems((lvcd.nmcd.dwItemSpec + 1)).Text)) = UCase(Trim(TestoRicerca1)) Then
                            lvcd.clrTextBk = vbGreen
                        End If
                        If UCase(Trim(frmMain.L1.ListItems((lvcd.nmcd.dwItemSpec + 1)).ListSubItems(2).Text)) = UCase(Trim(TestoRicerca2)) Then
                            lvcd.clrTextBk = vbRed
                        End If
                         
                        MoveMemory ByVal lParam, lvcd, Len(lvcd)
                        WndProc = CDRF_NOTIFYSUBITEMDRAW Or CDRF_NEWFONT
                        Exit Function
                    Case (CDDS_ITEMPREPAINT Or CDDS_SUBITEM)
                        
                        If blnColonneAlternate Then
                            If (lvcd.iSubItem Mod 2) Then
                                lvcd.clrText = InfoColonneAlternate.ColTestoColonnePari
                                lvcd.clrTextBk = InfoColonneAlternate.ColColonnePari
                            Else
                                lvcd.clrText = InfoColonneAlternate.ColTestoColonneDispari
                                lvcd.clrTextBk = InfoColonneAlternate.ColColonneDispari
                            End If
                        End If
                        
                        If blnColPers Then
                            Select Case lvcd.iSubItem
                                Case 0
                                    lvcd.clrTextBk = &HFFC0C0
                                Case 1
                                    lvcd.clrTextBk = vbWhite
                                Case 2
                                    lvcd.clrTextBk = vbWhite
                                Case 3
                                    lvcd.clrTextBk = vbWhite
                                Case 4
                                    lvcd.clrTextBk = vbBlue
                                    lvcd.clrText = vbWhite
                                Case 5
                                    lvcd.clrTextBk = vbYellow
                                    lvcd.clrText = vbBlack
                                Case 6
                                    lvcd.clrTextBk = vbWhite
                            End Select
                        End If
                        
                        MoveMemory ByVal lParam, lvcd, Len(lvcd)
                        WndProc = CDRF_NEWFONT
                        Exit Function
                End Select
        End Select

    Case WM_DESTROY
        Call CallWindowProc(GetProp(hWnd, OLDWNDPROC), hWnd, uMsg, wParam, lParam)
        Call UnSubClass(hWnd)
        Exit Function
End Select
WndProc = CallWindowProc(GetProp(hWnd, OLDWNDPROC), hWnd, uMsg, wParam, lParam)
End Function
