import java.lang.reflect.*;
import java.util.*;

public class DinamicClassLoader_2
{
  public static String strClassName = "DinamicClassLoader_2";

  /**  */
  public DinamicClassLoader_2(String strLocClassName)
  {
    try
    {
          //
          // Proviamo a creare un'istanza della classe
          //
                    
          Constructor constructor;
          Class objClass = Class.forName(strLocClassName);
          Object aObject = null;
          try
          {
              constructor = objClass.getConstructor(null);
              aObject = constructor.newInstance(null);
          }
          catch (Exception excp)
          {
              log("\tClasse senza costruttore di default: " + strLocClassName);
          }
          if (objClass == null)
          {
              log("\tImpossibile istanziare la classe: " + strLocClassName);
              return;
          }
          try
          {
            //            
            // Vediamo il package, il nome della classe e se viene estesa qualche altra classe
            //            
            log("\tPackage: " + convertNull(objClass.getPackage()));
            log("\tNome classe: " + objClass.getName());
            log("\tEstende: " + objClass.getSuperclass().getName());
          
            //            
            // Ora vediamo quale interfaccie implementa la classe ...
            //          
            Class[] objInterfaccie = objClass.getInterfaces();
            StringBuffer strInterfacce = new StringBuffer("\tImplementa: ");

            for (int i = 0; i < objInterfaccie.length; i++)
            {
                strInterfacce.append(objInterfaccie[i].getName() + " ");
            }          
            log(strInterfacce.toString());
            strInterfacce = null;
            objInterfaccie = null;

            //            
            // passiamo agli attributi visibili ... 
            //          
            Field[] objFields = objClass.getFields();
            log("\n\tAttributi visibili: " + objFields.length);
            for (int i = 0; i < objFields.length; i++)
            {
                Field x = objClass.getField(objFields[i].getName());
                log("\t\tAttributo " + (i + 1) + ": " + x + " = " + x.get(aObject));
            }
            objFields = null;
           
            //            
            // e alla lista di tutti gli attributi, pubblici e non ...
            //                      
            objFields = objClass.getDeclaredFields();
            log("\n\tAttributi (tutti): " + objFields.length);
            for (int i = 0; i < objFields.length; i++)
            {
                Field x = objFields[i];
                try
                {
                    log("\t\tAttributo " + (i + 1) + ": " + x + " = " + x.get(aObject));
                }
                catch (IllegalAccessException IllAccExcp)
                {
                    log("\t\tAttributo " + (i + 1) + ": " + x);
                }
            }
            objFields = null;
            
            //            
            // passiamo ai Costruttori visibili, compresi i parametri ...
            //                          
            Constructor[] objConstructors = objClass.getConstructors();
            log("\n\tCostruttori visibili: " + objConstructors.length);
            StringBuffer strParametri = new StringBuffer("");
            for (int i = 0; i < objConstructors.length; i++)
            {
                strParametri.append("\t\tCostruttore " + (i + 1) + ": " + objConstructors[i].getName() + "(");
                Class[] objParametri = objConstructors[i].getParameterTypes();
                for (int k = 0; k < objParametri.length; k++)
                {
                    if (k < objParametri.length - 1)
                        strParametri.append(objParametri[k].getName() + ",");
                    else
                        strParametri.append(objParametri[k].getName());
                }
                strParametri.append(");");
                log(strParametri.toString() );
                strParametri = null;
                objParametri = null;
                strParametri = new StringBuffer("");
            }
            objConstructors = null;
            strParametri = null;

            //            
            // ecco la lista di tutti i Costruttori dichiarati ...
            //                          
            objConstructors = objClass.getDeclaredConstructors();
            log("\n\tCostruttori (tutti): " + objConstructors.length);
            strParametri = new StringBuffer("");
            for (int i = 0; i < objConstructors.length; i++)
            {
                strParametri.append("\t\tCostruttore " + (i + 1) + ": " + objConstructors[i].getName() + "(");
                Class[] objParametri = objConstructors[i].getParameterTypes();
                for (int k = 0; k < objParametri.length; k++)
                {
                    if (k < objParametri.length - 1)
                        strParametri.append(objParametri[k].getName() + ",");
                    else
                        strParametri.append(objParametri[k].getName());
                }
                strParametri.append(");");
                log(strParametri.toString() );
                strParametri = null;
                objParametri = null;
                strParametri = new StringBuffer("");
            }
            objConstructors = null;
            strParametri = null;

            //            
            // ecco la lista dei Metodi visibili ...
            //                         
            Method[] objMethods = objClass.getMethods();
            log("\n\tMetodi visibili: " + objMethods.length);
            strParametri = new StringBuffer("");
            for (int i = 0; i < objMethods.length; i++)
            {
                strParametri.append("\t\tMetodo " + (i + 1) + ": " + objMethods[i].getReturnType().getName() + " " +
                objMethods[i].getName() + "(");
                Class[] objParametri = objMethods[i].getParameterTypes();
                for (int k = 0; k < objParametri.length; k++)
                {
                    if (k < objParametri.length - 1)
                        strParametri.append(objParametri[k].getName() + ",");
                    else
                        strParametri.append(objParametri[k].getName());
                }
                strParametri.append(");");
                log(strParametri.toString() );
                strParametri = null;
                objParametri = null;
                strParametri = new StringBuffer("");
            }
            objMethods = null;
            strParametri = null;

            //            
            // ecco la lista di tutti i Metodi ...
            //                               
            objMethods = objClass.getDeclaredMethods();
            log("\n\tMetodi (tutti): " + objMethods.length);
            strParametri = new StringBuffer("");
            for (int i = 0; i < objMethods.length; i++)            
            {
                strParametri.append("\t\tMetodo " + (i + 1) + ": " + objMethods[i].getReturnType().getName() + " " +
                objMethods[i].getName() + "(");
                Class[] objParametri = objMethods[i].getParameterTypes();
                for (int k = 0; k < objParametri.length; k++) {
                    if (k < objParametri.length - 1)
                        strParametri.append(objParametri[k].getName() + ",");
                    else
                        strParametri.append(objParametri[k].getName());
                }
                strParametri.append(");");
                log(strParametri.toString() );
                strParametri = null;
                objParametri = null;
                strParametri = new StringBuffer("");
            }
            objMethods = null;
            strParametri = null;
          }
          catch (Exception exc)
          {
                exc.printStackTrace();
          }
          finally
          {
            return;
          }
        }
        catch (Exception excp)
        {
          log("Impossibile istanziare la classe: " + strLocClassName);
          excp.printStackTrace();
        }
        finally
        {
            return;
        }
    }

    private String convertNull(Object objArg)
    {
        if (objArg == null)
            return "";
        else
            return objArg.toString();
    }

    public static void main(String args[]) throws Exception {
        if (args.length != 1) {
            printUsage();
            System.exit(1);
        }
        log("<-- INIZIO -->");
        DinamicClassLoader_2 objDinamicClassLoader_2 = new DinamicClassLoader_2(args[0]);
        log("<--  FINE  -->");
    }

    private static void printUsage() {
        log("\n\t\tUsage:\tjava DinamicClassLoader_2 <package.nomeclasse>");
    }

    private static void log(String strLog) {
        //System.out.println("\t" + strClassName + "::" + strLog);
        System.out.println(strLog);
    }
}
